//
//  DTMetaDataStore.h
//  DevonMetaData
//
//  Created by Annard Brouwer on 22/07/2008.
//  Copyright 2008 DEVONtechnologies, LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface DTMetaDataStore : NSObject

+ (NSSet *)metaDataKeysAtPath:(NSString *)aPath traverseLink:(BOOL)nory error:(NSError **)errorObject;

+ (NSDictionary *)metaDataDictionaryAtPath:(NSString *)aPath traverseLink:(BOOL)nory error:(NSError **)errorObject;
+ (BOOL)setMetaDataDictionary:(NSDictionary *)aDictionary atPath:(NSString *)aPath traverseLink:(BOOL)nory error:(NSError **)errorObject;

+ (id)objectForKey:(NSString *)aKey atPath:(NSString *)aPath traverseLink:(BOOL)nory error:(NSError **)errorObject;
+ (BOOL)setObject:(id)aValue forKey:(NSString *)aKey atPath:(NSString *)aPath traverseLink:(BOOL)nory error:(NSError **)errorObject;
+ (BOOL)removeObjectForKey:(NSString *)aKey atPath:(NSString *)aPath traverseLink:(BOOL)nory error:(NSError **)errorObject;

@end

// Added by cgrunenberg

@interface DTMetaDataStore (Tagging)

+ (BOOL)useOpenMeta;
+ (void)setUseOpenMeta:(BOOL)flag;

// Both OpenMeta & Mavericks tags are supported
+ (NSArray *)getUserTags:(NSString *)path error:(NSError **)errorObject;
+ (BOOL)setUserTags:(NSArray *)tags path:(NSString *)path error:(NSError **)errorObject;

+ (NSDate *)getUserTagsDate:(NSString *)path DEPRECATED_ATTRIBUTE;

@end

@interface NSDictionary (Tagging)

-(NSArray *)getUserTags;
-(NSArray *)getOpenMetaTags;
-(NSArray *)getMavericksTags;

@end

@interface DTMetaDataStore (DTAttributes)

+ (BOOL)setIsEditableNote:(BOOL)flag atPath:(NSString *)aPath traverseLink:(BOOL)nory error:(NSError **)errorObject;
+ (BOOL)setWhereFrom:(NSString *)strURL atPath:(NSString *)aPath traverseLink:(BOOL)nory error:(NSError **)errorObject;
+ (NSString *)finderCommentAtPath:(NSString *)aPath traverseLink:(BOOL)nory error:(NSError **)errorObject;

@end

@interface NSDictionary (DTAttributes)

-(BOOL)isEditableNote;
-(NSString *)getWhereFrom;

-(NSString *)getFinderComment;
-(NSString *)getItemTitleForFile:(NSString *)file;

@end